/*
Copyright 2010 Harteex Productions
License: Creative Commons Attribution 3.0 Unported
http://creativecommons.org/licenses/by/3.0/
*/
#include <stdlib.h>
#include <stdint.h>
#include "list.h"

void listInsertLast(list* list, void* data)
{
	list->count++;
	listNode* a = (listNode*)malloc(sizeof(listNode));
	a->data = data;
	a->next = NULL;

	if (list->first == NULL)
	{
		list->first = a;
		return;
	}

	listNode* cur = list->first;
	while (1)
	{
		if (cur->next == NULL)
		{
			//cur->next = (void *)a;
			cur->next = a;
			break;
		}

		cur = (listNode*)cur->next;
	}
}

void listDeleteAll(list* list)
{
	if (list->first == NULL)
		return;

	listNode* cur = list->first;
	list->first = NULL;
	while (cur != NULL)
	{
		listNode* temp = cur;
		//cur = (listNode*)cur->next;
		cur = cur->next;
		free(temp->data);
		free(temp);
	}

	list->count = 0;
}

void listDeleteFirst(list* list)
{
	if (list->first == NULL)
		return;

	listNode* temp = list->first;
	//cloneButtonPresses = (listNode*)cloneButtonPresses->next;
	list->first = temp->next;
	free(temp->data);
	free(temp);

	list->count--;
}

void* listGetFirst(list* list)
{
	if (list->first == NULL)
		return NULL;

	listNode* temp = list->first;
	return temp->data;
}
